SystemOrganization addCategory: #'Pier-Glamorous'!

GLMBrowserTemplate subclass: #PRPierWalker
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Glamorous'!

!PRPierWalker commentStamp: 'TudorGirba 5/16/2011 15:55' prior: 0!
This is a browser for editing a Pier kernel.

Default way of opening:
self openOn: PRKernel instances anyOne root.

Opening with the default user already logged in:
self new loginDefaultUser openOn: PRKernel instances anyOne root.!

!PRPierWalker methodsFor: 'private' stamp: 'TudorGirba 5/16/2011 14:00'!
actionForCommand: eachCommand
	| result |
	context := self context command: eachCommand new.
	PRCurrentContext
		use: self
		during: [ 
			result := (context command asMorph)
				addButtons;
				addWindow;
				callInWorld.
			result isNil
				ifFalse: [ 
					self
						context:
							((self context command)
								execute;
								answer) ] ].
	browser update! !

!PRPierWalker methodsFor: 'private' stamp: 'TudorGirba 5/16/2011 13:59'!
actionsFor: aContext
	^ (self commandsFor: aContext) collect: [ :eachCommand | 
			(GLMGenericAction new)
				action: [ :each | self actionForCommand: eachCommand ];
				title: eachCommand label;
				shortcut: eachCommand accessKey
				yourself ]! !

!PRPierWalker methodsFor: 'building' stamp: 'TudorGirba 5/22/2011 16:36'!
buildBrowser
	browser := GLMTabulator new title: 'Pier Walker'.
	browser
		column: #index;
		column: #contents span: 4.
	(browser transmit)
		to: #index;
		andShow: [ :a | self indexIn: a ].
	(browser transmit)
		to: #contents;
		from: #index;
		andShow: [ :a | self contentsIn: a ].
	^ browser! !

!PRPierWalker methodsFor: 'private' stamp: 'TudorGirba 5/16/2011 15:51'!
commandsFor: aContext
	| allCommands |
	allCommands := PRCommand withAllConcreteClasses
		reject: [ :each | each = PRViewCommand ].
	^ allCommands select: [ :each | each isValidIn: aContext ]! !

!PRPierWalker methodsFor: 'private' stamp: 'TudorGirba 5/14/2011 00:25'!
contentsIn: a
	^ (a magritte)
		title: 'Editor';
		description: [ :structure | structure editDescription ]
"		act: [ :magritte | 
					| context command |
					context := PRContext kernel: PRKernel instances anyOne structure: magritte entity.
					command := PRAddCommand new.
					context setUser: PRKernel instances anyOne users anyOne.
					context command: command.
					command execute.
					browser update ]
			icon: GLMUIThemeExtraIcons glamorousAdd
			entitled: 'Add'"
		"dynamicActions: [ :m | 
					| decoration |
					decoration := m entity securityDecoration.
					(decoration ownerPermissions , decoration groupPermissions , decoration otherPermissions) asOrderedCollection
						collect: [ :eachPermission | 
							(GLMGenericAction new)
								action: [ :each | eachPermission command execute ];
								title: eachPermission command name;
								yourself ] ]"! !

!PRPierWalker methodsFor: 'accessing' stamp: 'TudorGirba 5/14/2011 00:30'!
context
	^ context ifNil: [context := PRContext kernel: PRKernel instances anyOne]! !

!PRPierWalker methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2011 23:57'!
context: anObject
	context := anObject! !

!PRPierWalker methodsFor: 'private' stamp: 'TudorGirba 5/14/2011 00:30'!
indexIn: a
	^ (a tree)
		children: [ :page | page enumerator contents ];
		format: [ :page | page title ];
		title: 'Index';
		dynamicActionsOnSelection: [:tree | | decoration | 
			context := self context structure: tree selection.
			self actionsFor: context ]
"		selectionAct: [ :tree | 
					| context command |
					context := PRContext kernel: PRKernel instances anyOne structure: tree selection.
					command := PRRemoveCommand new.
					context setUser: PRKernel instances anyOne users anyOne.
					context command: command.
					command execute.
					tree update ]
			on: $x
			entitled: 'Remove'"! !

!PRPierWalker methodsFor: 'accessing' stamp: 'TudorGirba 5/16/2011 15:49'!
loginDefaultUser
	self context: (self context user: (self context kernel users anyOne))! !
